// closure to avoid namespace collision
(function(){
	// creates the plugin
	tinymce.create('tinymce.plugins.TOC', {
		// creates control instances based on the control's id.
		// our button's id is "TOC_button"
		createControl : function(id, controlManager) {
			if (id == 'TOC_button') {
				// creates the button
				var button = controlManager.createButton('TOC_button', {
					title : 'Simple TOC Shortcode', // title of the button
					image : '../wp-content/plugins/bainternet-simple-toc/toc_icon.png',  // path to the button's image
					onclick : function() {
						// triggers the thickbox
						var width = jQuery(window).width(), H = jQuery(window).height(), W = ( 720 < width ) ? 720 : width;
						W = W - 80;
						H = H - 84;
						tb_show( 'Simple TOC Shortcode', '#TB_inline?width=' + W + '&height=' + H + '&inlineId=toc-form' );
					}
				});
				return button;
			}
			return null;
		}
	});
	
	// registers the plugin. DON'T MISS THIS STEP!!!
	tinymce.PluginManager.add('TOC', tinymce.plugins.TOC);
	
	// executes this when the DOM is ready
	jQuery(function(){
		// creates a form to be displayed everytime the button is clicked
		// you should achieve this using AJAX instead of direct html code like this
		var form = jQuery('<div id="toc-form"><h2>Specify the Shortcode you want to insert.</h2><br /><ul><li><strong>Auto TOC heading</strong> -<small> insert once in the place you want your TOC to show, and specify the tag for heading (eg: h2,h3)</small></li><li><strong>TOC place holder </strong> -<small> insert once in the place you want your TOC to show</small></li><li><strong>TOC Header </strong>- <small>insert once or none at all, anywhere you want, this will show as the TOC heading</small></li><li><strong>TOC Heading </strong>- <small>insert as many headings as you want include there heading, this will be the text at the TOC link, insert where the heading is.</small></li><table id="TOC-table" class="form-table">\
			<tr>\
				<th><label for="TOC-sc_type">What to insert?</label></th>\
				<td><select name="type" id="TOC-sc_type">\
					<option value="4">Auto TOC heading</option>\
					<option value="1">TOC place holder</option>\
					<option value="2">TOC Header</option>\
					<option value="3">TOC Heading</option>\
				</select><br />\
				</td>\
			</tr>\
			<tr id="type_2" style="display: none;">\
					<th><label for="TOC-include">Table of contents header</label></th>\
					<td><input type="text" name="header" id="TOC-header" value="" /><br />\
					<small>Shown on The head of the TOC, add Only Once!!</small>\
					</td>\
			</tr>\
			<tr id="type_3" style="display: none;">\
					<th><label for="TOC-include">TOC ITEM heading</label></th>\
					<td><input type="text" name="heading" id="TOC-heading" value="" /><br />\
					<small>This will be the text of the TOC link ,Usually palce one above each heading in you content</small>\
					</td>\
			</tr>\
			<tr id="type_4">\
					<th><label for="TOC-include">Auto generate heading by tag</label></th>\
					<td><input type="text" name="tag" id="TOC-tag" value="" /><br />\
					<small>This smart shortcode generates headings for you , you just need to specify the heading tag, depends on your content ( but usually h2)</small>\
					</td>\
			</tr>\
		</table>\
		<p class="submit">\
			<input type="button" id="TOC-submit" class="button-primary" value="Insert" name="submit" />\
		</p>\
		</div>');
		
		var table = form.find('table');
		form.appendTo('body').hide();
		// handels the select event
		table.find('#TOC-sc_type').change(function(){
			if (table.find('#TOC-sc_type').val() == 1){
				table.find('#type_2').hide('fast');
				table.find('#type_3').hide('fast');
				table.find('#type_4').hide('fast');
			}
			if (table.find('#TOC-sc_type').val() == 2){
				table.find('#type_3').hide('fast');
				table.find('#type_4').hide('fast');
				table.find('#type_2').show('slow');
			}
			if (table.find('#TOC-sc_type').val() == 3){
				table.find('#type_2').hide('fast');
				table.find('#type_4').hide('fast');
				table.find('#type_3').show('slow');
			}
			if (table.find('#TOC-sc_type').val() == 4){
				table.find('#type_2').hide('fast');
				table.find('#type_3').hide('fast');
				table.find('#type_4').show('slow');
			}
		});
		
		// handles the click event of the submit button
		form.find('#TOC-submit').click(function(){
			// defines the options and their default values
			// again, this is not the most elegant way to do this
			// but well, this gets the job done nonetheless
			
			var shortcode = '[---TOC';
			
			if (table.find('#TOC-sc_type').val() == 2){
				shortcode += ' Header:' + table.find('#TOC-header').val();
			}
			if (table.find('#TOC-sc_type').val() == 3){
				shortcode += ' Heading:' + table.find('#TOC-heading').val();
			}			
			shortcode += '---]';
			if (table.find('#TOC-sc_type').val() == 4){
				shortcode = '[---ATOC---]  [---TAG:' + table.find('#TOC-tag').val();
				shortcode += '---]';
			}
			table.find('#TOC-heading').val('');
			table.find('#TOC-header').val('');
			table.find('#TOC-tag').val('');
			// inserts the shortcode into the active editor
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
			
			// closes Thickbox
			tb_remove();
		});
	});
})()